unit panelplayer;

interface

uses
  Windows, extctrls, stdctrls, SysUtils, Classes, Graphics, Controls, Dialogs,
  Buttons, Messages, Variants, Forms, Gauges, bass, tags, math;

type
     TLevel = Record  // Record for Property Level/OnPlaying
              left : byte;
              right: Byte;
              end;
     AFormats = Record  // Record for playble fileformats
                Name : String[30];
                Extension  : String[6];
                end;

type
     TPlayend       = Procedure (Sender:Tobject) of object;
     TPlaying       = Procedure (Sender:Tobject;Progress:Longint;Level:TLevel) of object;
     TPlaystop      = Procedure (Sender:TObject) of object;
     TPlayPause     = Procedure (Sender:Tobject) of object;
     TPlayError     = Procedure (Errormessage:String) of object;
     TPlaystart     = Procedure (Sender:Tobject;Progress:Longint) of object;

     TSpectralData  = array [0..512] of Single;
     TSoundData     = array [0..2048] of DWORD;

     TFormats       = array of AFormats;

var  Channel: Array[1..10] of HStream;


type
     TPanelPlayer = class(TPanel)

private
     { Private-Deklarationen }
     Paintframe  : TPaintbox;
     Playbtn     : TSpeedbutton;
     Stopbtn     : TSpeedbutton;
     Pausebtn    : TSpeedButton;
     Namelabel   : TLabel;
     Artistlabel : TLabel;
     Titlelabel  : TLabel;
     Timelabel   : Tlabel;
     Timer       : TTimer;
     Gauge       : Tgauge;
     FNumber     : Byte;
     FFilename   : String;
     FVolume     : byte;
     Fplaying    : TPlaying;
     FPaused     : TPlaypause;
     FPlayend    : TPlayend;
     FError      : TPlayerror;
     FStop       : TPlaystop;
     Fendpercent : Byte;
     Fbuttons    : Boolean;
     FLabels     : Boolean;
     FInit       : Boolean;
     Fisplaying  : Boolean;
     FPlaystart  : TPlaystart;
     FBassInfo   : BASS_INFO;
     FChannelInfo : BASS_CHANNELINFO;
     FLabelcolor : TColor;
     FCpu        : real;
     FLevel      : DWord;
     FSong       : String;
     FArtist     : String;
     FAlbum      : String;
     FTitle      : String;
     FPlaylength : String;
     FBar        : Boolean;
     Fselfinit   : Boolean;
     FSpecdata   : TSpectraldata;
     FWavedata   : TSounddata;
     FChannel    : HStream;
     FIspaused   : Boolean;
     FPosition   : Integer;
     FSpecHeight : Integer;
     FDrawType   : Integer;
     FDrawRes    : Integer;
     FPeakFall   : Integer;
     FLineFall   : Integer;
     FColWidth   : Integer;
     FShowPeak   : Boolean;
     FVisBuff    : TBitmap;
     FBackColor  : TColor;
     FPeakcolor  : Tcolor;
     FDrawcolor  : TColor;
     FFTPeacks   : array [0..128] of Integer;
     FFTFallOff  : array [0..128] of Integer;
     FFormats    : TFormats;


     //FTags       : Boolean;
    

// Private Procedures
     Procedure setnumber(Value :Byte);
     Procedure setfilename (Value:String);
     Procedure settimer(Sender:TObject);
     Procedure setvolume(Value:Byte);
     Procedure Setendpercent(Value:Byte);
     Procedure setbuttons(Value:Boolean);
     Procedure setlabels(Value:Boolean);
     Procedure setbar(Value:Boolean);
     Procedure SetBackcolor(Value:TColor);
     Procedure SetPeakcolor(Value:TColor);
     Procedure SetDrawcolor(Value:TColor);
     Procedure SetLabelcolor(Value:TColor);
     Procedure setlevel(value:DWord);
     Procedure Draw(HWND : THandle; FFTData : TSpectralData; X, Y : Integer);
     
// Private Functions
     Function  Getfilename:String;
     Function  GetChannel:HStream;
     Function  Getposition: LongInt;
     Function  GetLevel:TLevel;
     Function  GetNumber:Byte;
     Function  Getinitial: Boolean;
     Function  GetFormats: TFormats;
     Function  Createtime(const second:Real):String;
     Function  GetBackColor:TColor;
     Function  GetPeakColor:TColor;
     Function  GetDrawColor:TColor;


protected
     { Protected-Deklarationen }
     Procedure doresize(Sender:TObject);
     Procedure Paint;override;

public
     { Public-Deklarationen }
     Property Playing      : Boolean  read Fisplaying;
     Property Paused       : Boolean  read fispaused;
     Property CPU          : Real     read Fcpu;
     Property Level        : Tlevel   read getlevel;

     Property Song         : String   read fsong;
     Property Artist       : String   read FArtist;
     Property Title        : String   read FTitle;
     Property Album        : String   read FAlbum;
     Property Playlength   : String   read FPlaylength;
     Property Position     : LongInt  read GetPosition;
     Property Initialized  : Boolean  read GetInitial;
     Property Formats      : TFormats Read GetFormats;
     Property Bass_Channel : HStream  read FChannel;
published
    { Published-Deklarationen }
// Functions
     function     GetSpecdata  :TSpectraldata;
     function     GetWavedata  :TsoundData;
// Procedures
     Procedure    Play(Sender:TObject);
     Procedure    Stop(Sender:TObject);
     Procedure    Pause(Sender:TObject);
     Procedure    FreeFilename;
     Procedure    Loadplugin(const dllname:String);
// Properties
     Property     Number      : Byte       read getnumber   write setnumber;
     Property     Filename    : String     read getfilename write setfilename;
     Property     Volume      : Byte       read fvolume     write setvolume;
     Property     OnPlayEnd   : TPlayend   read fplayend    write fplayend;
     Property     OnPlaying   : TPlaying   read fplaying    write fplaying;
     Property     OnPlayStop  : TPlayStop  read fstop       write Fstop;
     Property     OnPlayPause : TPlaypause read Fpaused     write FPaused;
     Property     OnError     : TPlayError read Ferror      write Ferror;
     Property     OnPlayStart : TPlaystart read FPlaystart  write FPlaystart;
     Property     EndPercent  : Byte       read FEndpercent write SetEndpercent;
     Property     ShowButtons : Boolean    read Fbuttons    write setbuttons;
     Property     ShowLabels  : Boolean    read Flabels     write setlabels;
     Property     ShowBar     : Boolean    read FBar        write Setbar;
     Property     BackColor   : Tcolor     read GetBackColor   Write setbackcolor;
     Property     PeakColor   : Tcolor     read GetPeakcolor  Write setpeakcolor;
     Property     DrawColor   : Tcolor     read GetDrawcolor  Write setdrawcolor;
     Property     LabelColor  : Tcolor     read Flabelcolor Write setlabelcolor;
     Property     SelfInit    : Boolean    read fselfinit   write fselfinit;
     property     onmousedown;

    
// Constructor/Destructor
     Constructor  Create(AOwner:TComponent);Override;
     Destructor   Destroy;Override;
end;



procedure Register;



implementation

procedure TPanelplayer.Draw(HWND : THandle; FFTData : TSpectralData; X, Y : Integer);
var i, YPos : LongInt; YVal : Single;
// this draws the graphic to the paintbox
begin
        fVisBuff.Canvas.Pen.Color := FBackColor;
        fVisBuff.Canvas.Brush.Color := FBackColor;
        fVisBuff.Canvas.Rectangle(0, 0, fVisBuff.Width, fVisBuff.Height);
        fVisBuff.Canvas.Pen.Color := FDrawColor;
        for i := 0 to 128 do
        begin
           YVal := Abs(FFTData[(i * fDrawRes) + 5]);
           YPos := Trunc((YVal) * 500);
           if YPos > fVisbuff.Height then YPos := fSpecHeight;
           if YPos >= FFTPeacks[i] then FFTPeacks[i] := YPos
              else FFTPeacks[i] := FFTPeacks[i] - fPeakFall;
           if YPos >= FFTFallOff[i] then FFTFallOff[i] := YPos
              else FFTFallOff[i] := FFTFallOff[i] - fLineFall;
              if (fVisBuff.Height - FFTPeacks[i]) > fVisBuff.Height then FFTPeacks[i] := 0;
              if (fVisBuff.Height - FFTFallOff[i]) > fVisBuff.Height then FFTFallOff[i] := 0;
              case fDrawType of
                0 : begin
                       fVisBuff.Canvas.MoveTo(X + i, Y + fVisBuff.Height);
                       fVisBuff.Canvas.LineTo(X + i, Y + fVisBuff.Height - FFTFallOff[i]);
                       if fShowPeak then fVisBuff.Canvas.Pixels[X + i, Y + fVisBuff.Height - FFTPeacks[i]] := fDrawcolor;
                    end;
                1 : begin
                     if fShowPeak then fVisBuff.Canvas.Pen.Color := FPeakColor;
                     if fShowPeak then fVisBuff.Canvas.MoveTo(X + i * (fColWidth + 1), Y + fVisBuff.Height - FFTPeacks[i]);
                     if fShowPeak then fVisBuff.Canvas.LineTo(X + i * (fColWidth + 1) + fColWidth, Y + fVisBuff.Height - FFTPeacks[i]);
                     fVisBuff.Canvas.Pen.Color := FDrawColor;
                     fVisBuff.Canvas.Brush.Color := FDrawColor;
                     fVisBuff.Canvas.Rectangle(X + i * (fColWidth + 1), Y + fVisBuff.Height - FFTFallOff[i], X + i * (fColWidth + 1) + fColWidth, Y + fVisBuff.Height);
                    end;
              end;
        end;
        BitBlt(HWND, 0, 0, fVisBuff.Width, fVisBuff.Height, fVisBuff.Canvas.Handle, 0, 0, srccopy)
end;

Procedure TPanelPlayer.paint;
Begin
       inherited paint;
       PaintFrame.Canvas.Pen.Color := FBackColor;
       PaintFrame.Canvas.Brush.Color := FBackColor;
       fVisBuff.Width := paintframe.Width;
       fVisBuff.Height := Paintframe.Height;
       PaintFrame.Canvas.Rectangle(0, 0, PaintFrame.Width, PaintFrame.Height);
End;

procedure Register;
begin
        RegisterComponents('CR Soft', [TPanelPlayer]);
end;

Constructor TPanelPlayer.Create(AOwner: TComponent);
begin // Creating the player
        Inherited create(AOwner);
        width := 400;
        height := 160;
        OnResize:= doresize;
        Align := Alnone;
        fendpercent :=90;
        fbuttons:=true;
        FSelfinit := false;
        Fisplaying := false;
        FPeakcolor := ClRed;
        FDrawColor := ClLime;
  			FLabelcolor := font.Color;
        fVisBuff:=TBitmap.create;
        Fispaused := false;
        Flabels := true;
        fbar :=true;
        FPosition :=0;
        finit := false;
        // Setting Standard formats
        SetLength(Fformats,6);
        FFormats[0].Name := 'Frauenhofer';
        FFormats[0].Extension:='*.mp3';
        FFormats[1].Name := 'Musicam';
        FFormats[1].Extension := '*.mp2';
        FFormats[2].Name := 'Philips DCC';
        FFormats[2].Extension := '*.mp1';
        FFormats[3].Name := 'Vorbis OGG';
        FFormats[3].Extension:='*.ogg';
        FFormats[4].Name := 'Wave Format';
        FFormats[4].Extension := '*.wav';
        FFormats[5].Name := 'Apple AIFF';
        FFormats[5].Extension := '*.aif';
        PaintFrame:=TPaintbox.create(self);
        With Paintframe do
        begin // Creating the Bitmap
              parent := self;
              Top := 5;
              Left := 5;
              width := self.width -20;
              Height := self.height-90;
              canvas.Pen.color := FDrawColor;
              Canvas.brush.color := Fbackcolor;
              fVisBuff.Width := paintframe.Width;
              fVisBuff.Height := Paintframe.Height;
              onmousedown := self.OnMousedown;
        end;
        Stopbtn := TSpeedbutton.create(self);
        with Stopbtn do
        begin // The Stop Button
              parent := self;
              top := self.height-30;
              width := 40;
              left := self.width div 2 - stopbtn.width div 2;
              flat := true;
              caption :='Stop';
              Height := 24;
              Visible := true;
              onclick := Stop;
              parentcolor := self.ParentColor;
              parentfont := self.ParentFont;
        end;
        playbtn := TSpeedbutton.create(self);
        with playbtn do
        begin  // the PlayButton
               parent := self;
               top := self.height-30;
               flat := true;
               caption :='Play';
               width := 40;
               Height := 24;
               left := stopbtn.Left - playbtn.width-5;
               Visible := true;
               onclick := Play;
               parentcolor := self.ParentColor;
               parentfont := self.ParentFont;
        end;
        Pausebtn := TSpeedbutton.create(self);
        with Pausebtn do
        begin  // the PauseButton
               parent := self;
               top := self.height-30;
               left := stopbtn.left + stopbtn.width + 5;
               flat := true;
               caption :='Pause';
               width := 40;
               Height := 24;
               Visible := true;
               onclick := Pause;
               parentcolor := self.ParentColor;
               parentfont := self.ParentFont;
        end;
        Namelabel:=Tlabel.create(self);
        With Namelabel do
        begin  // Label for Filename
               Parent := self;
               caption := 'No file loaded';
               Top := self.height-105;
               Left :=5;
               parentfont := self.parentfont;
               parentcolor := self.ParentColor;
               onmousedown := self.OnMousedown;
        end;
        Artistlabel:=Tlabel.create(self);
        With Artistlabel do
        begin  // Label for Artist
               Parent := self;
               caption := 'No Artist Info';
               Top := self.height-50;
               Left :=5;
               parentfont := self.parentfont;
               parentcolor := self.ParentColor;
               onmousedown := self.OnMousedown;
        end;
        Titlelabel:=Tlabel.create(self);
        With Titlelabel do
        begin  // Label for Title
               Parent := self;
               caption := 'No Title Info';
               Top := self.height-35;
               Left :=5;
               parentfont := self.parentfont;
               parentcolor := self.ParentColor;
               onmousedown := self.OnMousedown;
        end;
        Timelabel:=Tlabel.create(self);
        With Timelabel do
        begin  // Label For Playtime
               Parent := self;
               caption := '00:00 min';
               Top := self.height-20;
               Left :=5;
               parentfont := self.parentfont;
               parentcolor := self.ParentColor;
               onmousedown := self.OnMousedown;
        end;
        Timer := TTimer.create(self);
        With timer do
        begin  // The Timer
               Enabled := false;
               interval := 25;
               ontimer := settimer;
        end;
        Gauge := TGauge.Create(self);
        With Gauge do
        begin // The Progressbar
              parent := self;
              progress := fposition;
              left := 5;
              Top := 90;
              width := self.width-10;
              height :=16;
              BackColor := Fbackcolor;
              ForeColor:= fDrawcolor;
              maxvalue := 100;
              borderstyle := bsNone;

        end;
        // Settings for the graphic
        fDrawRes  := 1;
        fSpecHeight := Paintframe.height-5;
        fDrawType := 1;
        fShowpeak := true;
        fPeakFall := 1;
        fLineFall := 3;
        fColWidth := 5;
        setvolume(50);
        
end;

Destructor Tpanelplayer.Destroy;
Begin // Free the Player with all components
        Namelabel.free;
        Artistlabel.Free;
        Timelabel.Free;
        Titlelabel.Free;
        Paintframe.free;
        fVisBuff.free;
        stopbtn.free;
        Gauge.free;
        Playbtn.Free;
        Pausebtn.free;
        timer.free;
        Inherited Destroy;
End;

Procedure Tpanelplayer.Settimer(Sender:TObject);
Begin // The Timer Procedure
        FCpu:=Bass_GetCpu;// Getting CPU Data
        if not (fisplaying) or (fispaused) then
               setlevel(0)// If not Playing
        else
               setlevel(bass_Channelgetlevel(channel[fnumber]));// Setting level if playing
        if Bass_channelisactive(channel[fnumber])=BASS_ACTIVE_PLAYING then
        begin // If player is Playing
              BASS_ChannelGetData(Channel[fnumber], @FSpecdata, BASS_DATA_FFT1024);// making the graphic
              Draw (Paintframe.Canvas.handle,FSpecdata,0,-1);
              BASS_ChannelGetData(Channel[fnumber], @FWaveData, 2048);//Getting Data for external use
              Fisplaying := true;// Player is Playing
              fposition:=round(Bass_channelgetposition(channel[fnumber],0)/Bass_ChannelGetLength(channel[fnumber],0)*100);//Actual position in percent (max 100)
              if getposition >= fendpercent then  // Making Playend
                 if assigned (onplayend) then
                    FPlayend (sender);
              if assigned (OnPlaying) then
                 FPlaying(Sender,bass_Channelgetposition(Channel[fnumber],0), getlevel);// Making OnPlaying
              if getposition >=  99 then
              begin  // If end of Song
                     stop(sender);
                     fposition :=0;
              end;
        end;
        if bass_channelisactive(Channel[fnumber])=BASS_ACTIVE_STOPPED then
        begin  // If Stopped
               Fisplaying := false;
               fposition :=0;
               paintframe.Canvas.brush.color := Fbackcolor;
               paintframe.Canvas.FillRect(Rect(0,0,paintframe.width,paintframe.Height)); // Clear the Bitmap
        end;
        if bass_channelisactive(Channel[fnumber])=BASS_ACTIVE_PAUSED then
           if Assigned(OnPlayPause) then
              Fpaused(Sender); // Making OnPaused
        // From here on all we need for
        timelabel.caption := 'Time: '+createtime(bass_channelbytes2seconds(Channel[fnumber],Bass_channelgetlength(channel[fnumber],0))-bass_channelbytes2seconds(Channel[fnumber],Bass_channelgetposition(channel[fnumber],0)));
        if fisplaying then
        begin  // Setting button status
             if not fispaused then
                stopbtn.enabled := true;
             pausebtn.Enabled := true;
             playbtn.Enabled := false;
        end
        else
        begin
             stopbtn.enabled := false;
             pausebtn.Enabled := false;
             if ffilename <> '' then
                playbtn.Enabled := true
             else
                playbtn.Enabled := false;
        end; // Setting Gauge Progress
        gauge.progress:=fposition;
End;

Procedure Tpanelplayer.Play(Sender:TObject);
begin // Starts Playing
       if ffilename ='' then
       begin  // If no Filename making errormessage (OnError)
              if assigned (onerror) then
                 ferror(SElf.Name+#13+'Es ist kein Dateiname angegeben!');
              exit;
       end;
       if Bass_channelisactive(channel[fnumber])<>BASS_ACTIVE_PLAYING then
       begin  // If Not playing (means stopped or paused)
              if not Bass_Channelplay(channel[fnumber],false) then
              begin // If not started the song  (Makes Error)
                    if assigned (onerror) then
                       ferror(self.Name+#13+'Kann Datei nicht abspielen!'+#13+'Bass Error: '+inttostr(Bass_Errorgetcode)+#13+'Bass Channel :'+inttostr(channel[fnumber]));
              end
              else
              begin // If Song starts

                    fposition :=0;
                    Timer.Enabled := true;
                    bass_Channelsetattribute(channel[number],BASS_ATTRIB_VOL,volume/100);// Volume to actual value
                    if assigned (OnPlaystart) then
                       fplaystart(Sender,bass_ChannelgetLength(channel[fnumber],0));//Sending Songlength for external use
              end;
       end;
end;

Procedure Tpanelplayer.stop(Sender:TObject);
begin // Stops the player
       if Bass_channelisactive(channel[fnumber])=BASS_ACTIVE_PLAYING then
       begin
            Bass_ChannelStop(Channel[fnumber]);
            Bass_Channelsetposition(Channel[fnumber],0,0);
            FLevel :=0;
            if assigned (OnPlaystop) then
               Fstop(Sender);
       end;
end;

Procedure Tpanelplayer.Pause(Sender:TObject);
begin // Player Paused
       if Bass_channelisactive(channel[fnumber])=BASS_ACTIVE_PLAYING then
       begin
            Bass_Channelpause(Channel[fnumber]);
            Fispaused := true;
            FLevel :=0;
            Stopbtn.Enabled := false;
            if assigned(OnPlaypause) then
               Fpaused(sender);
       end
       else
       begin
            Bass_Channelplay(Channel[fnumber],false);
            Fispaused := false;
            Stopbtn.Enabled := true;
            if assigned(OnPlaypause) then
               Fpaused(sender);
       end;
end;

Procedure Tpanelplayer.setnumber(Value :Byte);
// Player number. Must be different if using more than one player
begin
      if value > 10 then
          value :=0;
      fnumber := value;
end;

Procedure Tpanelplayer.setfilename (Value:String);
// Setting Filename
Begin
     if fnumber = 0 then
     // If no playernumber or playernumber > 9 then error
     begin
          if assigned (OnError) then
             FError(self.Name+#13+'Es ist keine Playernummer gesetzt');
          Exit;
     end;
     ffilename := value;
     if not fileexists(value) then
     begin // If file wasn't found by the player
           if assigned (onerror) then
              ferror( self.name+#13+'Die Datei '+value+' existiert nicht!');
           Namelabel.caption := 'No file loaded';
           freefilename;
           exit;
     end;
     if value ='' then
     begin // If No Filename
           if assigned (onerror) then
              ferror( self.name+#13+'Es ist kein Dateiname angegeben!');
           Namelabel.caption := 'No file loaded';
           freefilename;
           exit;
     end;
     fposition :=0;
     gauge.progress := FPosition;
     if (fselfinit) and not(Finit) then // if property selfinit and not selfinit done
     begin
          if (HIWORD(BASS_GetVersion) <> BASSVERSION) then
	        begin
		           if assigned (OnError) then
                  FError(self.Name+#13+'Eine falsche Version der Bass.dll wurde geladen');
               exit;
          end;
          if not BASS_Init(-1, 44100, 0,Handle, nil) then
          begin
               if assigned (onerror) then
                  if not finit then
                     ferror(self.Name+#13+'Konnte bass.dll nicht initialisieren!');
          end
          else Finit:=true;// remember selfinit is done
     end;

     try
         Channel[fnumber]:=bass_streamcreatefile(False,pchar(FFilename),0,0,0{$IFDEF UNICODE} or BASS_UNICODE {$ENDIF});
     finally
          if channel[fnumber] =0 then
          begin
               if assigned (onerror)
                  then ferror(self.Name+#13+'Kann die Datei '+value+' nicht laden!'+#13+'Bass Error: '+inttostr(Bass_Errorgetcode));
               freefilename;
          end;
     end;
     if ffilename ='' then
        exit;
     FChannel:=CHannel[fnumber]; // Playerchannel for external use
     if CHannel[fnumber] >0 then
     begin
          Namelabel.caption := extractfilename (fFilename);
          FSong := Namelabel.Caption;
               FTitle :=String(TAGS_READ(channel[fnumber],'%TITL'));
               if length(FTitle) < 2 then
                  FTitle := extractfileName(FFileName);
               titlelabel.caption := 'Title: '+FTitle;
               FArtist := String(TAGS_READ(channel[fnumber],'%ARTI'));
               if length(FArtist)<2 then
                  FArtist := '';
               artistlabel.caption := 'Artist: '+FArtist;
               FAlbum := String(TAGS_READ(channel[fnumber],'%ALBM'));
          FPlaylength := createtime(bass_channelbytes2seconds(Channel[fnumber],Bass_channelgetlength(channel[fnumber],0)));
     end
     else
         if assigned(Onerror) then
            Ferror(self.Name+#13+'Konnte keinen Channel finden.'+#13+'Bass Error: '+inttostr(Bass_ErrorgetCode));
End;

function Tpanelplayer.getfilename:String;
// Getting Filename
begin
        result := ffilename;
end;

Procedure Tpanelplayer.setvolume(Value: Byte);
// Setting volume (Max. 100%)
begin
        if value > 100 then
           value :=100;
        fvolume := value;
           if Channel[fnumber]>0 then
              Bass_Channelsetattribute(Channel[fnumber],BASS_ATTRIB_VOL,value/100);
end;

Procedure Tpanelplayer.doresize(sender:TObject);
// If Player is  resized
Begin
       if self.width < 300 then
          self.width := 300;
       if self.Height < 160 then
          self.Height := 160;
       With Paintframe do
       begin
            width := self.width -10;
            Height := self.height-90;
            fVisBuff.Width := paintframe.Width;
            fVisBuff.Height := paintframe.Height;
            fSpecHeight := Paintframe.height-5;
       end;
       with Stopbtn do
       begin
            top := self.Height-30;
            left := self.Width div 2 - stopbtn.width div 2;
            parentfont := self.parentfont;
            parentcolor := self.ParentColor;
       end;
       with playbtn do
       begin
            top := self.Height-30;
            left := stopbtn.Left - playbtn.Width-5;
            parentfont := self.parentfont;
            parentcolor := self.ParentColor;
       end;
       with Pausebtn do
       begin
            top := self.Height-30;
            left := stopbtn.left+stopbtn.width+5;
            parentfont := self.parentfont;
            parentcolor := self.ParentColor;
       end;
       With Namelabel do
       begin
            Top := self.Height-85;
            Left :=5;
            parentfont := self.parentfont;
            parentcolor := self.ParentColor;
       end;
       With Gauge do
       begin
            progress := 0;
            left := 5;
            Top := self.Height-70;
            width := self.width-10;
            parentfont := self.parentfont;
            parentcolor := self.ParentColor;
            borderstyle := bsnone;
       end;
       With Artistlabel do
       begin
            Top := self.height-50;
            Left :=5;
            parentfont := self.parentfont;
            parentcolor := self.ParentColor;
       end;
       With Titlelabel do
       begin
            Top := self.height-35;
            Left :=5;
            parentfont := self.parentfont;
            parentcolor := self.ParentColor;
       end;
       With Timelabel do
       begin
            Top := self.height-20;
            Left :=5;
            parentfont := self.parentfont;
            parentcolor := self.ParentColor;
       end;
End;

Procedure Tpanelplayer.Setendpercent(Value:Byte);
// Setting percentige for playend
Begin
      if value > 100  then
         value := 100;
      Fendpercent := value;
End;

Procedure Tpanelplayer.setbuttons(Value: Boolean);
// Setting buttons visible
begin
      fbuttons := value;
      playbtn.visible := value;
      Stopbtn.visible := value;
      PauseBtn.visible := value;
end;

Procedure Tpanelplayer.setlabels(Value: Boolean);
// Setting Labels Visible
begin
      flabels := value;
      Artistlabel.visible := value;
      Namelabel.visible := value;
      Timelabel.visible := value;
      Titlelabel.visible := value;
end;

Procedure Tpanelplayer.setbar(Value: Boolean);
// Setting Bar visible
begin
      fbar := value;
      gauge.Visible:=value;
end;

Function Tpanelplayer.Createtime(const second:Real):String;
// Making the time shown in timelabel
var min,sec:Integer;
Begin
      sec := trunc(second);
      if sec <= 0 then
         result :='00:00 min'
      else
      begin
           min := sec div 60;
           sec := sec-min*60;
           if min < 10 then
              result:='0'+inttostr(min)
           else
              result := inttostr(min);
           if sec < 10 then
              result := result+':0'+inttostr(sec)+' min'
           else
              result := result+':'+inttostr(sec)+' min';
      end;
End;

Procedure Tpanelplayer.Setbackcolor(Value:TColor);
// Setting Backcolor
begin
      fbackcolor := value;
      gauge.BackColor:=fbackcolor;
end;

Procedure Tpanelplayer.SetPeakcolor(Value:TColor);
// Setting Peakcolor for graphic
begin
      fpeakcolor := value;
end;

Procedure Tpanelplayer.SetDrawcolor(Value:TColor);
// Setting Drawcolor for Graphic
begin
      fDrawcolor := value;
      gauge.ForeColor:=fdrawcolor;
end;

Procedure Tpanelplayer.SetLabelcolor(Value:TColor);
// Setting Color for Labels etc.
begin
      fLabelcolor := value;
      Namelabel.font.color :=value;
      Artistlabel.font.Color :=value;
      Titlelabel.font.color :=value;
      TimeLabel.Font.color := value;
      playbtn.Font.Color := value;
      stopbtn.Font.Color := value;
      pausebtn.font.color := value;
end;

Procedure TPanelplayer.setlevel(Value:DWord);
// Setting Level
Begin
      FLevel := Value;
end;

procedure Tpanelplayer.freefilename;
// Freefilename: Makes the bass channel free and resets the labels etc
Begin
      if channel[fnumber] <>0 then
      begin
          bass_streamfree(Channel[fnumber]);
          channel[fnumber]:=0;
      end;
      ffilename :='';
      artistlabel.caption := 'No Artist Info';
      Timelabel.caption :='00:00 min';
      Titlelabel.caption := 'No Title Info';
      Namelabel.caption := 'No file loaded';
      FArtist := 'No Artist Info';
      FPlaylength :='00:00';
      FTitle := 'No Tilte Info';
      FSong := 'No File loaded';
      FisPaused := false;
      FIsPlaying :=false;
End;

function  Tpanelplayer.GetSpecdata:TSpectraldata;
// Gets Specdata for external use
begin
      result := FSpecdata;
end;

function  Tpanelplayer.GetWavedata:TsoundData;
// Gets WaveData for external use
Begin
      result := FWavedata;
End;

function  Tpanelplayer.GetChannel:HStream;
// Channel for external use
Begin
      result := CHannel[fnumber];
End;

function  Tpanelplayer.GetPosition:LongInt;
// Position in byte
Begin
      result := FPosition;
End;

function TPanelplayer.getlevel:TLevel;
// Level for external use
Begin
      if FIsPlaying then
      begin
           result.right:= Round(hiword(Flevel)/$7fff*100);
           result.left := Round(loword(Flevel)/$7fff*100);
      end
      else
      begin
           result.right:= 0;
           result.left := 0;
      end;
end;

Function  TPanelplayer.GetNumber:Byte;
// Getting the Playernumber
Begin
      result := FNumber;
end;

Function TPanelPlayer.Getinitial:Boolean;
// Is the player initialized?
begin
      result := finit;
end;

Function TPanelPlayer.GetFormats:TFormats;
// the playble formats for external use in property Formats
Begin
      result := FFormats;
end;

Procedure TPanelPlayer.Loadplugin(const Dllname:String);
// Load Plugin Info from Bass Plugins
var plugin: HPlugin;
    Info: PBass_PluginInfo;
begin

    Plugin := Bass_Pluginload(pchar(dllname),0{$IFDEF UNICODE}or BASS_UNICODE{$ENDIF});
    if plugin >0 then //Plugin was loaded (Ok)
    begin
          setlength(FFormats,high(FFormats)+2);// One more
          Info := BASS_PluginGetInfo(Plugin);   // Gets the Plugin Info
          FFormats[high(FFormats)].Name:=Info.Formats[0].name;  // Name of Plugin from Info
          FFormats[high(FFormats)].Extension:= info.Formats[0].exts;// Extension of Plugin From Info
    end
    else   // Plugin wasn't loaded
          if assigned (OnError) then
              FError(self.Name+#13+'Konnte '+#13+DllName+#13+' nicht laden!');
end;

Function TPanelPlayer.GetBackColor:Tcolor;
begin
      Result := FBackcolor
end;

Function TPanelPlayer.GetPeakColor:Tcolor;
begin
      Result := FPeakcolor
end;

Function TPanelPlayer.GetDrawColor:Tcolor;
begin
      Result := FDrawcolor
end;


end.
